"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const icons_1 = require("@ant-design/icons");
const antd_1 = require("antd");
const classnames_1 = __importDefault(require("classnames"));
const useMergedState_1 = __importDefault(require("rc-util/es/hooks/useMergedState"));
const react_1 = require("react");
const index_less_1 = __importDefault(require("./index.less"));
const HeaderSearch = (props) => {
    const { className, defaultValue, onVisibleChange, placeholder, visible, defaultVisible, ...restProps } = props;
    const inputRef = (0, react_1.useRef)(null);
    const [value, setValue] = (0, useMergedState_1.default)(defaultValue, {
        value: props.value,
        onChange: props.onChange,
    });
    const [searchMode, setSearchMode] = (0, useMergedState_1.default)(defaultVisible !== null && defaultVisible !== void 0 ? defaultVisible : false, {
        value: props.visible,
        onChange: onVisibleChange,
    });
    const inputClass = (0, classnames_1.default)(index_less_1.default.input, {
        [index_less_1.default.show]: searchMode,
    });
    return ((0, jsx_runtime_1.jsxs)("div", { className: (0, classnames_1.default)(className, index_less_1.default.headerSearch), onClick: () => {
            setSearchMode(true);
            if (searchMode && inputRef.current) {
                inputRef.current.focus();
            }
        }, onTransitionEnd: ({ propertyName }) => {
            if (propertyName === 'width' && !searchMode) {
                if (onVisibleChange) {
                    onVisibleChange(searchMode);
                }
            }
        }, children: [(0, jsx_runtime_1.jsx)(icons_1.SearchOutlined, { style: {
                    cursor: 'pointer',
                } }, "Icon"), (0, jsx_runtime_1.jsx)(antd_1.AutoComplete, { className: inputClass, value: value, options: restProps.options, onChange: (completeValue) => setValue(completeValue), children: (0, jsx_runtime_1.jsx)(antd_1.Input, { size: "small", ref: inputRef, defaultValue: defaultValue, "aria-label": placeholder, placeholder: placeholder, onKeyDown: (e) => {
                        if (e.key === 'Enter') {
                            if (restProps.onSearch) {
                                restProps.onSearch(value);
                            }
                        }
                    }, onBlur: () => {
                        setSearchMode(false);
                    } }) }, "AutoComplete")] }));
};
exports.default = HeaderSearch;
