"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
// import { outLogin } from '@/services/ant-design-pro/api';
const icons_1 = require("@ant-design/icons");
// @ts-ignore
const max_1 = require("@umijs/max");
const antd_1 = require("antd"); // Avatar
const react_1 = require("react");
const HeaderDropdown_1 = __importDefault(require("../HeaderDropdown"));
const index_less_1 = __importDefault(require("./index.less"));
const auth_1 = require("../../utils/auth");
/**
 * 退出登录，并且将当前的 url 保存
 */
// const loginOut = async () => {
// await outLogin();
// const { search, pathname } = history.location;
// const urlParams = new URL(window.location.href).searchParams;
// /** 此方法会跳转到 redirect 参数所在的位置 */
// const redirect = urlParams.get('redirect');
// // Note: There may be security issues, please note
// if (window.location.pathname !== '/user/login' && !redirect) {
//   history.replace({
//     pathname: '/user/login',
//     search: stringify({
//       redirect: pathname + search,
//     }),
//   });
// }
// };
const AvatarDropdown = ({ menu }) => {
    const { initialState, setInitialState } = (0, max_1.useModel)('@@initialState');
    const onMenuClick = (0, react_1.useCallback)((event) => {
        const { key } = event;
        if (key === 'logout') {
            // setInitialState((s:any) => ({ ...s, currentUser: undefined }));
            // loginOut();
            (0, auth_1.userLogOut)();
            return;
        }
        max_1.history.push(`/account/${key}`);
    }, [setInitialState]);
    const loading = ((0, jsx_runtime_1.jsx)("span", { className: `${index_less_1.default.action} ${index_less_1.default.account}`, children: (0, jsx_runtime_1.jsx)(antd_1.Spin, { size: "small", style: {
                marginLeft: 8,
                marginRight: 8,
            } }) }));
    if (!initialState) {
        return loading;
    }
    const { userInfo } = initialState;
    if (!userInfo || !userInfo.accountName) {
        return loading;
    }
    const menuItems = [
        ...(menu
            ? [
                {
                    key: 'center',
                    icon: (0, jsx_runtime_1.jsx)(icons_1.UserOutlined, {}),
                    label: '个人中心',
                },
                {
                    key: 'settings',
                    icon: (0, jsx_runtime_1.jsx)(icons_1.SettingOutlined, {}),
                    label: '个人设置',
                },
                {
                    type: 'divider',
                },
            ]
            : []),
        {
            key: 'logout',
            icon: (0, jsx_runtime_1.jsx)(icons_1.LogoutOutlined, {}),
            label: '退出登录',
        },
    ];
    const menuHeaderDropdown = ((0, jsx_runtime_1.jsx)(antd_1.Menu, { className: index_less_1.default.menu, selectedKeys: [], onClick: onMenuClick, items: menuItems }));
    return ((0, jsx_runtime_1.jsx)(HeaderDropdown_1.default, { overlay: menuHeaderDropdown, children: (0, jsx_runtime_1.jsx)("span", { className: `${index_less_1.default.action} ${index_less_1.default.account}`, children: (0, jsx_runtime_1.jsx)("span", { className: `${index_less_1.default.name} anticon`, children: userInfo.accountName }) }) }));
};
exports.default = AvatarDropdown;
