"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInitialState = exports.patchClientRoutes = exports.request = exports.layout = void 0;
const runtimeConfig_1 = __importStar(require("./runtimeConfig"));
let { layout, request, patchClientRoutes, getInitialState, access } = runtimeConfig_1.default;
exports.layout = layout;
exports.request = request;
exports.patchClientRoutes = patchClientRoutes;
exports.getInitialState = getInitialState;
const initialValue = [
    'getInitialState',
    'layout',
    'patchClientRoutes',
    'request',
    'rootContainer',
    'patchRoutes',
    'onRouteChange',
    'qiankun',
    'render',
    'access',
];
function registerGenerator({ name, type, fn, options }) {
    if (!initialValue.includes(name)) {
        return;
    }
    switch (name) {
        case 'getInitialState':
            if (!options)
                return;
            exports.getInitialState = getInitialState = (0, runtimeConfig_1.enhanceInitialState)({ options }); //支持钩子回调、不支持覆盖
            break;
        case 'request':
            if (!options)
                return;
            exports.request = request = (0, runtimeConfig_1.enhanceRequest)({ options, covered: type === 'cover' }); //支持拓展、支持覆盖
            break;
        case 'layout':
            if (!fn)
                return;
            exports.layout = layout = (0, runtimeConfig_1.enhanceLayout)({ fn, covered: type === 'cover' }); //支持拓展、支持覆盖
            break;
        case 'patchClientRoutes':
            if (!fn)
                return;
            exports.patchClientRoutes = patchClientRoutes = (0, runtimeConfig_1.enhancePatchClientRoutes)({ fn, covered: type === 'cover' }); //支持回调、支持覆盖
            break;
        case 'access':
            if (!fn)
                return;
            access = (0, runtimeConfig_1.enhanceAccess)({ fn }); //支持拓展、不支持覆盖
            break;
        // case 'rootContainer':
        //   rootContainer = fn
        //   break;
        // case 'onRouteChange':
        //   onRouteChange = fn
        //   break;
        // case 'patchRoutes':
        //   patchRoutes = fn
        //   break;
        // case 'qiankun':
        //   qiankun = fn
        //   break;
        // case 'render':
        //   render = fn
        //   break;
    }
}
exports.default = {
    access: () => {
        return access;
    },
    registerGenerator
};
