"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const api_1 = require("../../../services/api");
const auth_1 = require("../../../utils/auth");
const icons_1 = require("@ant-design/icons");
const pro_components_1 = require("@ant-design/pro-components");
// @ts-ignore
const max_1 = require("@umijs/max");
const utils_1 = require("../../../utils");
const antd_1 = require("antd");
const react_1 = require("react");
const index_less_1 = __importDefault(require("./index.less"));
const LoginMessage = ({ content }) => {
    return ((0, jsx_runtime_1.jsx)(antd_1.Alert, { style: {
            marginBottom: 24,
        }, message: content, type: "error", showIcon: true }));
};
const Login = () => {
    const [userLoginState, setUserLoginState] = (0, react_1.useState)({});
    const [type, setType] = (0, react_1.useState)('mobile');
    const { initialState, setInitialState } = (0, max_1.useModel)('@@initialState');
    const fetchUserInfo = async () => {
        var _a;
        const userInfo = await ((_a = initialState === null || initialState === void 0 ? void 0 : initialState.fetchUserInfo) === null || _a === void 0 ? void 0 : _a.call(initialState));
        await setInitialState((s) => {
            const { exception, fakeLogin, ...rest } = s;
            return {
                ...rest,
                ...(userInfo ? userInfo : {}),
            };
        });
    };
    const handleSubmit = async (values) => {
        try {
            // 登录
            const { username, password } = values;
            const res = await (0, api_1.fakeLogin)({ username, password });
            const { code, data = {} } = res;
            if (code === 0) {
                // 获取用户 TOKEN 并设置
                const { token } = data;
                (0, auth_1.setAccessToken)(token);
                antd_1.message.success('登录成功！');
                await fetchUserInfo();
                /** 此方法会跳转到 redirect 参数所在的位置 */
                if (!max_1.history)
                    return;
                max_1.history.replace((0, utils_1.getQueryString)('redirect') || '/');
                return;
            }
            // 如果失败去设置用户错误信息
            setUserLoginState({ status: 'error' });
        }
        catch (error) {
            console.log(error);
            antd_1.message.error('登录失败，请重试！');
        }
    };
    (0, react_1.useEffect)(() => {
        if ((0, utils_1.getQueryString)('fake_login')) {
            setType('account');
        }
    }, []);
    const { status, type: loginType } = userLoginState;
    return ((0, jsx_runtime_1.jsx)("div", { className: index_less_1.default.container, children: (0, jsx_runtime_1.jsx)("div", { className: index_less_1.default.content, children: (0, jsx_runtime_1.jsxs)(pro_components_1.LoginForm, { initialValues: {
                    autoLogin: true,
                }, onFinish: async (values) => {
                    await handleSubmit(values);
                }, children: [status === 'error' && loginType === 'account' && ((0, jsx_runtime_1.jsx)(LoginMessage, { content: "\u8D26\u6237\u6216\u5BC6\u7801\u9519\u8BEF" })), type === 'account' && ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)("div", { className: index_less_1.default.title, children: "Fake\u767B\u5F55" }), (0, jsx_runtime_1.jsx)(pro_components_1.ProFormText, { name: "username", fieldProps: {
                                    size: 'large',
                                    prefix: (0, jsx_runtime_1.jsx)(icons_1.UserOutlined, { className: index_less_1.default.prefixIcon }),
                                }, placeholder: "\u7528\u6237\u540D:\u57DF\u8D26\u53F7", rules: [
                                    {
                                        required: true,
                                        message: "请输入用户名",
                                    },
                                ] }), (0, jsx_runtime_1.jsx)(pro_components_1.ProFormText.Password, { name: "password", fieldProps: {
                                    size: 'large',
                                    prefix: (0, jsx_runtime_1.jsx)(icons_1.LockOutlined, { className: index_less_1.default.prefixIcon }),
                                }, placeholder: "\u5BC6\u7801:\u4EFB\u610F\u5B57\u7B26", rules: [
                                    {
                                        required: true,
                                        message: "请输入密码！",
                                    },
                                ] })] })), status === 'error' && loginType === 'mobile' && (0, jsx_runtime_1.jsx)(LoginMessage, { content: "\u9A8C\u8BC1\u7801\u9519\u8BEF" }), type === 'mobile' && ((0, jsx_runtime_1.jsxs)(jsx_runtime_1.Fragment, { children: [(0, jsx_runtime_1.jsx)("div", { className: index_less_1.default.title, children: "\u6B22\u8FCE\u4F7F\u7528360\u95EE\u5377" }), (0, jsx_runtime_1.jsx)(pro_components_1.ProFormText, { fieldProps: {
                                    size: 'large',
                                    prefix: (0, jsx_runtime_1.jsx)(icons_1.MobileOutlined, { className: index_less_1.default.prefixIcon }),
                                }, name: "mobile", placeholder: "\u624B\u673A\u53F7", rules: [
                                    {
                                        required: true,
                                        message: "请输入手机号！",
                                    },
                                    {
                                        pattern: /^1\d{10}$/,
                                        message: "手机号格式错误！",
                                    },
                                ] }), (0, jsx_runtime_1.jsx)(pro_components_1.ProFormCaptcha, { fieldProps: {
                                    size: 'large',
                                    prefix: (0, jsx_runtime_1.jsx)(icons_1.LockOutlined, { className: index_less_1.default.prefixIcon }),
                                }, captchaProps: {
                                    size: 'large',
                                }, phoneName: "mobile", placeholder: "\u8BF7\u8F93\u5165\u9A8C\u8BC1\u7801", captchaTextRender: (timing, count) => {
                                    if (timing) {
                                        return `${count}获取验证码`;
                                    }
                                    return '获取验证码';
                                }, name: "captcha", rules: [
                                    {
                                        required: true,
                                        message: "请输入验证码！",
                                    },
                                ], onGetCaptcha: async (phone) => {
                                    try {
                                        await (0, api_1.getCaptcha)({
                                            phone,
                                        });
                                        antd_1.message.success('获取验证码成功');
                                    }
                                    catch (e) {
                                        throw new Error("获取验证码失败");
                                    }
                                } })] }))] }) }) }));
};
exports.default = Login;
