"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.enhanceAccess = exports.access = void 0;
const Authorized_1 = require("../../utils/Authorized");
/**
 * @see https://umijs.org/zh-CN/plugins/plugin-access
 * */
function access(initialState, fn) {
    return {
        generalAccess: (authority) => {
            return (0, Authorized_1.checkPermissions)(authority);
        },
        routeAccess: (route) => {
            const { authority } = route;
            return (0, Authorized_1.checkPermissions)(authority);
        },
        ...(fn ? fn(initialState) || {} : {})
    };
}
exports.access = access;
function enhanceAccess({ fn }) {
    if (!fn) {
        return access;
    }
    return (initialState) => {
        return access(initialState, fn);
    };
}
exports.enhanceAccess = enhanceAccess;
