"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.enhanceLayout = exports.layout = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const Footer_1 = __importDefault(require("../../components/Footer"));
const RightContent_1 = __importDefault(require("../../components/RightContent"));
const base_1 = require("@teams-max/base");
const utils_1 = require("../../utils");
const auth_1 = require("../../utils/auth");
const base_2 = require("@teams-max/base");
const { platform, isIntranet } = (0, base_2.runtimeConfig)();
const { isTeams } = platform;
const loginPath = '/user/login';
function handlePageChange({ initialState }, location) {
    console.log('history', location.pathname, initialState);
    if (initialState.fakeLogin) {
        if (location.pathname !== loginPath) {
            (0, auth_1.userLogOut)('fake_login');
        }
        return;
    }
    if (initialState.exception) {
        (0, utils_1.setException)(initialState.exception);
        return;
    }
    if (!(initialState === null || initialState === void 0 ? void 0 : initialState.token)) {
        const type = !isTeams && !isIntranet ? 'mobileNum' : undefined;
        (0, auth_1.userLogOut)(type);
        return;
    }
}
const layout = ({ initialState, setInitialState }, fn) => {
    return {
        rightContentRender: () => (0, jsx_runtime_1.jsx)(RightContent_1.default, {}),
        disableContentMargin: false,
        footerRender: () => (0, jsx_runtime_1.jsx)(Footer_1.default, {}),
        onPageChange: (location) => {
            handlePageChange({ initialState, setInitialState }, location);
        },
        menuHeaderRender: undefined,
        childrenRender: (children) => {
            if (initialState === null || initialState === void 0 ? void 0 : initialState.loading)
                return (0, jsx_runtime_1.jsx)("div", { children: "loading..." });
            return ((0, jsx_runtime_1.jsx)(jsx_runtime_1.Fragment, { children: children }));
        },
        ...base_1.defaultSettings,
        ...initialState === null || initialState === void 0 ? void 0 : initialState.settings,
        ...(fn ? fn({ initialState }) || {} : {})
    };
};
exports.layout = layout;
function enhanceLayout({ fn, covered }) {
    if (!fn) {
        return exports.layout;
    }
    if (covered) {
        return fn;
    }
    return ({ initialState, setInitialState }) => {
        return (0, exports.layout)({ initialState, setInitialState }, fn);
    };
}
exports.enhanceLayout = enhanceLayout;
