"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.enhancePatchClientRoutes = exports.patchClientRoutes = exports.filterRoutes = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const base_1 = require("@teams-max/base");
const react_1 = __importStar(require("react"));
const routes_1 = __importDefault(require("./routes"));
const { platform: { isMobile }, } = (0, base_1.runtimeConfig)();
function dynamicComp(component) {
    const Comp = react_1.default.lazy(() => Promise.resolve().then(() => __importStar(require(/* webpackChunkName: "dynamic-component" */ `@teams-max/core/page/${component}`))));
    return ((0, jsx_runtime_1.jsx)(react_1.Suspense, { fallback: (0, jsx_runtime_1.jsx)("div", { children: "loading" }), children: (0, jsx_runtime_1.jsx)(Comp, {}) }));
}
function joinCompPath(compPath) {
    const splitPath = compPath.split('/');
    if (splitPath.length > 1 && (splitPath[0] === '.' || !splitPath[0])) {
        return splitPath.slice(1).join('/');
    }
    return compPath;
}
function getPatchedRoutes(routes) {
    return routes.map((item) => {
        const nextItem = {
            ...item,
            ...(item.routes
                ? { routes: getPatchedRoutes(item.routes), children: getPatchedRoutes(item.routes) }
                : {}),
        };
        if (nextItem.component) {
            const { component, ...restItem } = nextItem;
            return {
                ...restItem,
                element: typeof component === 'string' ? dynamicComp(joinCompPath(component)) : component, //react-router-v6 component替换为element
            };
        }
        return nextItem;
    });
}
function filterRoutes(routes, filterFlag = { key: 'isMobile', value: isMobile }) {
    const nextRoutes = routes.filter((route) => {
        const { extra = {} } = route;
        if (route.routes) {
            route.routes = filterRoutes(route.routes);
        }
        if (route.children) {
            route.children = filterRoutes(route.children);
        }
        return extra[filterFlag.key] === undefined || extra[filterFlag.key] === filterFlag.value;
    });
    return nextRoutes;
}
exports.filterRoutes = filterRoutes;
function patchClientRoutes({ routes }, fn) {
    const patchedRoutes = getPatchedRoutes(routes_1.default);
    patchedRoutes.forEach((route) => {
        routes.unshift(route);
    });
    // eslint-disable-next-line no-param-reassign
    routes = filterRoutes(routes);
    console.log('patchClientRoutes', routes);
    fn && fn({ routes });
}
exports.patchClientRoutes = patchClientRoutes;
function enhancePatchClientRoutes({ fn, covered }) {
    if (!fn) {
        return patchClientRoutes;
    }
    if (covered) {
        return fn;
    }
    return ({ routes }) => {
        return patchClientRoutes({ routes }, fn);
    };
}
exports.enhancePatchClientRoutes = enhancePatchClientRoutes;
