"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.robotSend = exports.mchAuthLogin = exports.queryUsersByRoleKey = exports.getAuthorityQuery = exports.getUserInfo = exports.logOut = exports.fetchShorten = exports.fetchGenShorten = exports.login = exports.fakeLogin = exports.getCaptcha = void 0;
/* eslint-disable */
// @ts-ignore
const max_1 = require("@umijs/max");
async function getCaptcha(data = {}) {
    return (0, max_1.request)('/getCaptcha', {
        method: 'POST',
        data,
    });
}
exports.getCaptcha = getCaptcha;
// Fake 登录
async function fakeLogin(data = {}) {
    return (0, max_1.request)('/token/account/login/mock', {
        method: 'POST',
        data,
    });
}
exports.fakeLogin = fakeLogin;
// SSO 登录
async function login(data = {}) {
    return (0, max_1.request)('/token/ticket/login', {
        method: 'POST',
        data,
    });
}
exports.login = login;
// Token 转 短Key
async function fetchGenShorten() {
    return (0, max_1.request)('/token/generate/temEncrypt', {
        method: 'POST',
    });
}
exports.fetchGenShorten = fetchGenShorten;
// 短Key 转 Token
async function fetchShorten(params = {}) {
    return (0, max_1.request)('/token/user/getTokenByEncrypt', {
        method: 'GET',
        params,
    });
}
exports.fetchShorten = fetchShorten;
// SSO 退出
async function logOut(Authorization) {
    return (0, max_1.request)('/token/logout', {
        method: 'POST',
        headers: { Authorization },
    });
}
exports.logOut = logOut;
// 用户信息查询
async function getUserInfo() {
    return (0, max_1.request)('/token/user/query/cache', {
        method: 'POST',
    });
}
exports.getUserInfo = getUserInfo;
// 菜单列表
async function getAuthorityQuery() {
    return (0, max_1.request)('/token/authority/query', {
        method: 'POST',
    });
}
exports.getAuthorityQuery = getAuthorityQuery;
// 业务接口查询
async function queryUsersByRoleKey() {
    return (0, max_1.request)('/upms/user/authorization/queryUsersByRoleKey/PTYH', {
        method: 'GET',
    });
}
exports.queryUsersByRoleKey = queryUsersByRoleKey;
// 第三方商户自动登录处理
async function mchAuthLogin(url, data = {}) {
    return (0, max_1.request)(url || '/dgt/shimo/loginAuth/login', {
        method: 'POST',
        data,
    });
}
exports.mchAuthLogin = mchAuthLogin;
// 机器人报警
async function robotSend(url, data = {}) {
    return (0, max_1.request)(url, {
        method: 'POST',
        data,
        headers: {
            useErrorTips: false,
        },
    });
}
exports.robotSend = robotSend;
