/**
 * 获取用户 TOKEN
 * @return  {string}  处理过的用户 TOKEN
 */
export function getAccessToken(): string;
/**
 * 设置用户 TOKEN
 * @return  {string}  处理过的用户 TOKEN
 */
export function setAccessToken(accessToken: any): string;
/**
 * 设置用户信息
 * @return  {string}  处理过的用户 TOKEN
 */
export function setUserProfile(userInfo?: {}): string;
/**
 * 获取用户信息
 * @return  {string}  处理过的用户 TOKEN
 */
export function getUserProfile(): string;
/**
 * TOKEN 转 短Key
 * @return  {string}  处理过的 短Key
 */
export function genShorten(url: any, antoJump?: boolean): string;
/**
 * 短Key 转 TOKEN
 * @return  {string}  处理过的用户 TOKEN
 */
export function genAccessToken(encrypt: any): string;
/**
 * 清除用户 TOKEN
 * @return  {undefined}  undefined
 */
export function clearAccessToken(): undefined;
/**
 * 设置错误信息
 */
export function setErrorInfo(code: any, value?: {}): void;
/**
 * 获取错误信息
 * @return  {string}  处理过的错误信息
 */
export function getErrorInfo(code: any): string;
/**
 * 用户退出
 */
export function userLogOut(type: any): Promise<void>;
/**
 * 第三方应用登录
 * @param { * 第三方登录链接 } mchUrl
 * @param { * 登录成功后的回调方法 } callback fn | url
 */
export function openMchUrl(mchUrl: any, callback: any): Promise<void>;
//# sourceMappingURL=auth.d.ts.map