/**
 * 获取当前 URL 参数
 * @return  {Object}  处理过的 URL 参数
 */
export function getPageQuery(url: any): Object;
/**
 * 获取地址栏参数
 * @param 参数名
 * @returns {string | null}
 */
export function getQueryString(name: any, rmHash?: boolean): string | null;
export function getQueryPath(path?: string, query?: {}): string;
/**
 * 去掉空格
 * @param {string} 要去掉空格的字符串
 * @param   {Boolean} 是否去掉字符串中间的空格
 * @return  {String}  处理过的字符串
 */
export function trim(str: any, isGlobal: any): string;
/**
 * 将Json数据转为String
 * @name    jsonToString
 * @param   {Object}  要转化的json对象
 * @param   {Boolean} 是否要进行转码以备URL传输
 * @return  {String}  转化后的字符串
 */
export function jsonToString(json: any, isEncode: any): string;
/**
 * 如果是个方法执行一下它
 */
export function runFunction(valueEnum: any, ...rest: any[]): any;
/**
 * 获取cookie和设置cookie
 * @name    cookie
 * @param   {String}  名字
 * @param   {String}  值
 * @param   {Object}  配置选项
 * @return  {String}  当只有名字时返回名字对应值
 */
export function cookie(name: any, value: any, options: any): string;
/**
 * 删除cookie的快捷方法
 * @name    removeCookie
 * @param   {String}  名字
 */
export function removeCookie(key: any): void;
/**
 * Date 对象判断
 * @param {Date} value 要检查的 Date 对象
 * @returns {String} 返回Date 对象 结果
 */
export function isValidDate(value: Date): string;
/**
 * 日期时间格式化
 * @param {Date | String | Number} value 时间、类时间对象
 * @param {String} format 格式：yyyy-MM-dd hh:mm:ss:S
 * @param {Boolean} isCoerce 是否对类时间格式强制转换
 * @returns {String} 返回格式化后的值
 */
export function datetimeFormat(value: Date | string | number, format: string, isCoerce: boolean): string;
export function initSecurity(userId: any, userName: any): void;
export function setException(res: any, redirect: any): void;
export function getQueryStr(query: any, isEncode?: boolean): string;
export function urlReset(key: any): void;
import APILoader from "./APILoader";
export function isUrl(path: any): boolean;
/** 判断是否是图片链接 */
export function isImg(path: any): boolean;
export function isNil(value: any): boolean;
export { APILoader };
//# sourceMappingURL=index.d.ts.map