export default WebSocketServer;
/**
 *
 * https://developer.mozilla.org/zh-CN/docs/Web/API/WebSocket
 */
/**
 * 定义WebSocket类
 */
declare class WebSocketServer {
    /**
     * WebSocket类构造函数
     * @param {String} loadChartOption 加载的图表选项
     */
    constructor(url: any);
    url: string;
    ws: WebSocket;
    lastHealthTime: number;
    healthMessage: string;
    reconnect: number;
    reconnectMark: boolean;
    keepAliveTimer: NodeJS.Timer | null;
    message: any;
    /**
     * 心跳动作
     * @returns {Object} 返回数据结果对象
     */
    keepalive(): Object;
    /**
     * 连接失败
     * @param {String} selector 连接失败后的回调函数
     */
    onerror(fn: any): void;
    /**
     * 连接成功后，并发送链接参数
     */
    onopen(message: any): void;
    /**
     * 心跳动作
     * @returns {Object} 返回数据结果对象
     */
    heartBeat(message: any): Object;
    timmer: any;
    /**
     * 从服务器接受到信息
     * @returns {Object} 返回数据结果对象
     */
    onmessage(fn: any): Object;
    /**
     * 关闭指定连接
     */
    onclose(type?: string): void;
}
//# sourceMappingURL=socket.d.ts.map